Package org.springframework.validation

# Class BindException

java.lang.Object
java.lang.Throwable
java.lang.Exception
org.springframework.validation.BindException

All Implemented Interfaces:
  `Serializable`, `BindingResult`, `Errors`

public class BindException extends Exception implements BindingResult
Thrown when binding errors are considered fatal. Implements the `BindingResult` interface (and its super-interface `Errors`) to allow for the direct analysis of binding errors.

As of Spring 2.0, this is a special-purpose class. Normally, application code will work with the `BindingResult` interface, or with a `DataBinder` that in turn exposes a BindingResult via `DataBinder.getBindingResult()`.

Author:
  Rod Johnson, Juergen Hoeller, Rob Harrop
See Also:
  - `BindingResult`
  - `DataBinder.getBindingResult()`
  - `DataBinder.close()`
  - Serialized Form

## Field Summary

### Fields inherited from interface org.springframework.validation.BindingResult

`MODEL_KEY_PREFIX`

### Fields inherited from interface org.springframework.validation.Errors

`NESTED_PATH_SEPARATOR`

## Constructor Summary

Constructors
Constructor
Description
`BindException(Object target, String objectName)`
Create a new BindException instance for a target bean.
`BindException(BindingResult bindingResult)`
Create a new BindException instance for a BindingResult.

## Method Summary

Modifier and Type
Method
Description
`void`
`addAllErrors(Errors errors)`
Add all errors from the given `Errors` instance to this `Errors` instance.
`void`
`addError(ObjectError error)`
Add a custom `ObjectError` or `FieldError` to the errors list.
`boolean`
`equals(Object other)`
`PropertyEditor`
`findEditor(String field, Class valueType)`
Find a custom property editor for the given type and property.
`List<ObjectError>`
`getAllErrors()`
Get all errors, both global and field ones.
`final BindingResult`
`getBindingResult()`
Return the BindingResult that this BindException wraps.
`int`
`getErrorCount()`
Determine the total number of errors.
`FieldError`
`getFieldError()`
Get the first error associated with a field, if any.
`FieldError`
`getFieldError(String field)`
Get the first error associated with the given field, if any.
`int`
`getFieldErrorCount()`
Determine the number of errors associated with a field.
`int`
`getFieldErrorCount(String field)`
Determine the number of errors associated with the given field.
`List<FieldError>`
`getFieldErrors()`
Get all errors associated with a field.
`List<FieldError>`
`getFieldErrors(String field)`
Get all errors associated with the given field.
`Class<?>`
`getFieldType(String field)`
Determine the type of the given field, as far as possible.
`Object`
`getFieldValue(String field)`
Return the current value of the given field, either the current bean property value or a rejected update from the last binding.
`ObjectError`
`getGlobalError()`
Get the first global error, if any.
`int`
`getGlobalErrorCount()`
Determine the number of global errors.
`List<ObjectError>`
`getGlobalErrors()`
Get all global errors.
`String`
`getMessage()`
Returns diagnostic information about the errors held in this object.
`Map<String,Object>`
`getModel()`
Return a model Map for the obtained state, exposing a BindingResult instance as '`MODEL_KEY_PREFIX` + objectName' and the object itself as 'objectName'.
`String`
`getNestedPath()`
Return the current nested path of this `Errors` object.
`String`
`getObjectName()`
Return the name of the bound root object.
`org.springframework.beans.PropertyEditorRegistry`
`getPropertyEditorRegistry()`
Return the underlying PropertyEditorRegistry.
`Object`
`getRawFieldValue(String field)`
Extract the raw field value for the given field.
`String[]`
`getSuppressedFields()`
Return the list of fields that were suppressed during the bind process.
`Object`
`getTarget()`
Return the wrapped target object, which may be a bean, an object with public fields, a Map - depending on the concrete binding strategy.
`boolean`
`hasErrors()`
Determine if there were any errors.
`boolean`
`hasFieldErrors()`
Determine if there were any errors associated with a field.
`boolean`
`hasFieldErrors(String field)`
Determine if there were any errors associated with the given field.
`boolean`
`hasGlobalErrors()`
Determine if there were any global errors.
`int`
`hashCode()`
`void`
`popNestedPath()`
Pop the former nested path from the nested path stack.
`void`
`pushNestedPath(String subPath)`
Push the given sub path onto the nested path stack.
`void`
`recordFieldValue(String field, Class<?> type, Object value)`
Record the given value for the specified field.
`void`
`recordSuppressedField(String field)`
Mark the specified disallowed field as suppressed.
`void`
`reject(String errorCode)`
Register a global error for the entire target object, using the given error description.
`void`
`reject(String errorCode, Object[] errorArgs, String defaultMessage)`
Register a global error for the entire target object, using the given error description.
`void`
`reject(String errorCode, String defaultMessage)`
Register a global error for the entire target object, using the given error description.
`void`
`rejectValue(String field, String errorCode)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`void`
`rejectValue(String field, String errorCode, Object[] errorArgs, String defaultMessage)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`void`
`rejectValue(String field, String errorCode, String defaultMessage)`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`String[]`
`resolveMessageCodes(String errorCode)`
Resolve the given error code into message codes.
`String[]`
`resolveMessageCodes(String errorCode, String field)`
Resolve the given error code into message codes for the given field.
`void`
`setNestedPath(String nestedPath)`
Allow context to be changed so that standard validators can validate subtrees.

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.springframework.validation.Errors

`failOnError, toString`

## Constructor Details

### BindException

public BindException(BindingResult bindingResult)
Create a new BindException instance for a BindingResult.

Parameters:
  `bindingResult` - the BindingResult instance to wrap

### BindException

public BindException(Object target, String objectName)
Create a new BindException instance for a target bean.

Parameters:
  `target` - the target bean to bind onto
  `objectName` - the name of the target object
See Also:
  - `BeanPropertyBindingResult`

## Method Details

### getBindingResult

public final BindingResult getBindingResult()
Return the BindingResult that this BindException wraps.

### getObjectName

public String getObjectName()
Description copied from interface: `Errors`
Return the name of the bound root object.

Specified by:
  `getObjectName` in interface `Errors`

### setNestedPath

public void setNestedPath(String nestedPath)
Description copied from interface: `Errors`
Allow context to be changed so that standard validators can validate subtrees. Reject calls prepend the given path to the field names.

For example, an address validator could validate the subobject "address" of a customer object.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support nested paths.

Specified by:
  `setNestedPath` in interface `Errors`
Parameters:
  `nestedPath` - nested path within this object, for example, "address" (defaults to "", `null` is also acceptable). Can end with a dot: both "address" and "address." are valid.
See Also:
  - `Errors.getNestedPath()`

### getNestedPath

public String getNestedPath()
Description copied from interface: `Errors`
Return the current nested path of this `Errors` object.

Returns a nested path with a dot, i.e. "address.", for easy building of concatenated paths. Default is an empty String.

Specified by:
  `getNestedPath` in interface `Errors`
See Also:
  - `Errors.setNestedPath(String)`

### pushNestedPath

public void pushNestedPath(String subPath)
Description copied from interface: `Errors`
Push the given sub path onto the nested path stack.

A `Errors.popNestedPath()` call will reset the original nested path before the corresponding `pushNestedPath(String)` call.

Using the nested path stack allows to set temporary nested paths for subobjects without having to worry about a temporary path holder.

For example: current path "spouse.", pushNestedPath("child") → result path "spouse.child."; popNestedPath() → "spouse." again.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support nested paths.

Specified by:
  `pushNestedPath` in interface `Errors`
Parameters:
  `subPath` - the sub path to push onto the nested path stack
See Also:
  - `Errors.popNestedPath()`

### popNestedPath

public void popNestedPath() throws IllegalStateException
Description copied from interface: `Errors`
Pop the former nested path from the nested path stack.

Specified by:
  `popNestedPath` in interface `Errors`
Throws:
  `IllegalStateException` - if there is no former nested path on the stack
See Also:
  - `Errors.pushNestedPath(String)`

### reject

public void reject(String errorCode)
Description copied from interface: `Errors`
Register a global error for the entire target object, using the given error description.

Specified by:
  `reject` in interface `Errors`
Parameters:
  `errorCode` - error code, interpretable as a message key
See Also:
  - `Errors.reject(String, Object[], String)`

### reject

public void reject(String errorCode, String defaultMessage)
Description copied from interface: `Errors`
Register a global error for the entire target object, using the given error description.

Specified by:
  `reject` in interface `Errors`
Parameters:
  `errorCode` - error code, interpretable as a message key
  `defaultMessage` - fallback default message
See Also:
  - `Errors.reject(String, Object[], String)`

### reject

public void reject(String errorCode, @Nullable Object[] errorArgs, @Nullable String defaultMessage)
Description copied from interface: `Errors`
Register a global error for the entire target object, using the given error description.

Specified by:
  `reject` in interface `Errors`
Parameters:
  `errorCode` - error code, interpretable as a message key
  `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
  `defaultMessage` - fallback default message
See Also:
  - `Errors.rejectValue(String, String, Object[], String)`

### rejectValue

public void rejectValue(@Nullable String field, String errorCode)
Description copied from interface: `Errors`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Specified by:
  `rejectValue` in interface `Errors`
Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
See Also:
  - `Errors.rejectValue(String, String, Object[], String)`

### rejectValue

public void rejectValue(@Nullable String field, String errorCode, String defaultMessage)
Description copied from interface: `Errors`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Specified by:
  `rejectValue` in interface `Errors`
Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
  `defaultMessage` - fallback default message
See Also:
  - `Errors.rejectValue(String, String, Object[], String)`

### rejectValue

public void rejectValue(@Nullable String field, String errorCode, @Nullable Object[] errorArgs, @Nullable String defaultMessage)
Description copied from interface: `Errors`
Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

Specified by:
  `rejectValue` in interface `Errors`
Parameters:
  `field` - the field name (may be `null` or empty String)
  `errorCode` - error code, interpretable as a message key
  `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
  `defaultMessage` - fallback default message
See Also:
  - `Errors.reject(String, Object[], String)`

### addAllErrors

public void addAllErrors(Errors errors)
Description copied from interface: `Errors`
Add all errors from the given `Errors` instance to this `Errors` instance.

This is a convenience method to avoid repeated `reject(..)` calls for merging an `Errors` instance into another `Errors` instance.

Note that the passed-in `Errors` instance is supposed to refer to the same target object, or at least contain compatible errors that apply to the target object of this `Errors` instance.

The default implementation throws `UnsupportedOperationException` since not all `Errors` implementations support `#addAllErrors`.

Specified by:
  `addAllErrors` in interface `Errors`
Parameters:
  `errors` - the `Errors` instance to merge in
See Also:
  - `Errors.getAllErrors()`

### hasErrors

public boolean hasErrors()
Description copied from interface: `Errors`
Determine if there were any errors.

Specified by:
  `hasErrors` in interface `Errors`
See Also:
  - `Errors.hasGlobalErrors()`
  - `Errors.hasFieldErrors()`

### getErrorCount

public int getErrorCount()
Description copied from interface: `Errors`
Determine the total number of errors.

Specified by:
  `getErrorCount` in interface `Errors`
See Also:
  - `Errors.getGlobalErrorCount()`
  - `Errors.getFieldErrorCount()`

### getAllErrors

public List<ObjectError> getAllErrors()
Description copied from interface: `Errors`
Get all errors, both global and field ones.

Specified by:
  `getAllErrors` in interface `Errors`
Returns:
  a list of `ObjectError`/`FieldError` instances
See Also:
  - `Errors.getGlobalErrors()`
  - `Errors.getFieldErrors()`

### hasGlobalErrors

public boolean hasGlobalErrors()
Description copied from interface: `Errors`
Determine if there were any global errors.

Specified by:
  `hasGlobalErrors` in interface `Errors`
See Also:
  - `Errors.hasFieldErrors()`

### getGlobalErrorCount

public int getGlobalErrorCount()
Description copied from interface: `Errors`
Determine the number of global errors.

Specified by:
  `getGlobalErrorCount` in interface `Errors`
See Also:
  - `Errors.getFieldErrorCount()`

### getGlobalErrors

public List<ObjectError> getGlobalErrors()
Description copied from interface: `Errors`
Get all global errors.

Specified by:
  `getGlobalErrors` in interface `Errors`
Returns:
  a list of `ObjectError` instances
See Also:
  - `Errors.getFieldErrors()`

### getGlobalError

@Nullable public ObjectError getGlobalError()
Description copied from interface: `Errors`
Get the first global error, if any.

Specified by:
  `getGlobalError` in interface `Errors`
Returns:
  the global error, or `null`
See Also:
  - `Errors.getFieldError()`

### hasFieldErrors

public boolean hasFieldErrors()
Description copied from interface: `Errors`
Determine if there were any errors associated with a field.

Specified by:
  `hasFieldErrors` in interface `Errors`
See Also:
  - `Errors.hasGlobalErrors()`

### getFieldErrorCount

public int getFieldErrorCount()
Description copied from interface: `Errors`
Determine the number of errors associated with a field.

Specified by:
  `getFieldErrorCount` in interface `Errors`
See Also:
  - `Errors.getGlobalErrorCount()`

### getFieldErrors

public List<FieldError> getFieldErrors()
Description copied from interface: `Errors`
Get all errors associated with a field.

Specified by:
  `getFieldErrors` in interface `Errors`
Returns:
  a List of `FieldError` instances
See Also:
  - `Errors.getGlobalErrors()`

### getFieldError

@Nullable public FieldError getFieldError()
Description copied from interface: `Errors`
Get the first error associated with a field, if any.

Specified by:
  `getFieldError` in interface `Errors`
Returns:
  the field-specific error, or `null`
See Also:
  - `Errors.getGlobalError()`

### hasFieldErrors

public boolean hasFieldErrors(String field)
Description copied from interface: `Errors`
Determine if there were any errors associated with the given field.

Specified by:
  `hasFieldErrors` in interface `Errors`
Parameters:
  `field` - the field name
See Also:
  - `Errors.hasFieldErrors()`

### getFieldErrorCount

public int getFieldErrorCount(String field)
Description copied from interface: `Errors`
Determine the number of errors associated with the given field.

Specified by:
  `getFieldErrorCount` in interface `Errors`
Parameters:
  `field` - the field name
See Also:
  - `Errors.getFieldErrorCount()`

### getFieldErrors

public List<FieldError> getFieldErrors(String field)
Description copied from interface: `Errors`
Get all errors associated with the given field.

Implementations may support not only full field names like "address.street" but also pattern matches like "address.*".

Specified by:
  `getFieldErrors` in interface `Errors`
Parameters:
  `field` - the field name
Returns:
  a List of `FieldError` instances
See Also:
  - `Errors.getFieldErrors()`

### getFieldError

@Nullable public FieldError getFieldError(String field)
Description copied from interface: `Errors`
Get the first error associated with the given field, if any.

Specified by:
  `getFieldError` in interface `Errors`
Parameters:
  `field` - the field name
Returns:
  the field-specific error, or `null`
See Also:
  - `Errors.getFieldError()`

### getFieldValue

@Nullable public Object getFieldValue(String field)
Description copied from interface: `Errors`
Return the current value of the given field, either the current bean property value or a rejected update from the last binding.

Allows for convenient access to user-specified field values, even if there were type mismatches.

Specified by:
  `getFieldValue` in interface `Errors`
Parameters:
  `field` - the field name
Returns:
  the current value of the given field
See Also:
  - `Errors.getFieldType(String)`

### getFieldType

@Nullable public Class<?> getFieldType(String field)
Description copied from interface: `Errors`
Determine the type of the given field, as far as possible.

Implementations should be able to determine the type even when the field value is `null`, for example from some associated descriptor.

Specified by:
  `getFieldType` in interface `Errors`
Parameters:
  `field` - the field name
Returns:
  the type of the field, or `null` if not determinable
See Also:
  - `Errors.getFieldValue(String)`

### getTarget

@Nullable public Object getTarget()
Description copied from interface: `BindingResult`
Return the wrapped target object, which may be a bean, an object with public fields, a Map - depending on the concrete binding strategy.

Specified by:
  `getTarget` in interface `BindingResult`

### getModel

public Map<String,Object> getModel()
Description copied from interface: `BindingResult`
Return a model Map for the obtained state, exposing a BindingResult instance as '`MODEL_KEY_PREFIX` + objectName' and the object itself as 'objectName'.

Note that the Map is constructed every time you're calling this method. Adding things to the map and then re-calling this method will not work.

The attributes in the model Map returned by this method are usually included in the `org.springframework.web.servlet.ModelAndView` for a form view that uses Spring's `bind` tag in a JSP, which needs access to the BindingResult instance. Spring's pre-built form controllers will do this for you when rendering a form view. When building the ModelAndView instance yourself, you need to include the attributes from the model Map returned by this method.

Specified by:
  `getModel` in interface `BindingResult`
See Also:
  - `Errors.getObjectName()`
  - `BindingResult.MODEL_KEY_PREFIX`
  - `org.springframework.web.servlet.ModelAndView`
  - `org.springframework.web.servlet.tags.BindTag`

### getRawFieldValue

@Nullable public Object getRawFieldValue(String field)
Description copied from interface: `BindingResult`
Extract the raw field value for the given field. Typically used for comparison purposes.

Specified by:
  `getRawFieldValue` in interface `BindingResult`
Parameters:
  `field` - the field to check
Returns:
  the current value of the field in its raw form, or `null` if not known

### findEditor

@Nullable public PropertyEditor findEditor(@Nullable String field, @Nullable Class valueType)
Description copied from interface: `BindingResult`
Find a custom property editor for the given type and property.

Specified by:
  `findEditor` in interface `BindingResult`
Parameters:
  `field` - the path of the property (name or nested path), or `null` if looking for an editor for all properties of the given type
  `valueType` - the type of the property (can be `null` if a property is given but should be specified in any case for consistency checking)
Returns:
  the registered editor, or `null` if none

### getPropertyEditorRegistry

@Nullable public org.springframework.beans.PropertyEditorRegistry getPropertyEditorRegistry()
Description copied from interface: `BindingResult`
Return the underlying PropertyEditorRegistry.

Specified by:
  `getPropertyEditorRegistry` in interface `BindingResult`
Returns:
  the PropertyEditorRegistry, or `null` if none available for this BindingResult

### resolveMessageCodes

public String[] resolveMessageCodes(String errorCode)
Description copied from interface: `BindingResult`
Resolve the given error code into message codes.

Calls the configured `MessageCodesResolver` with appropriate parameters.

Specified by:
  `resolveMessageCodes` in interface `BindingResult`
Parameters:
  `errorCode` - the error code to resolve into message codes
Returns:
  the resolved message codes

### resolveMessageCodes

public String[] resolveMessageCodes(String errorCode, String field)
Description copied from interface: `BindingResult`
Resolve the given error code into message codes for the given field.

Calls the configured `MessageCodesResolver` with appropriate parameters.

Specified by:
  `resolveMessageCodes` in interface `BindingResult`
Parameters:
  `errorCode` - the error code to resolve into message codes
  `field` - the field to resolve message codes for
Returns:
  the resolved message codes

### addError

public void addError(ObjectError error)
Description copied from interface: `BindingResult`
Add a custom `ObjectError` or `FieldError` to the errors list.

Intended to be used by cooperating strategies such as `BindingErrorProcessor`.

Specified by:
  `addError` in interface `BindingResult`
See Also:
  - `ObjectError`
  - `FieldError`
  - `BindingErrorProcessor`

### recordFieldValue

public void recordFieldValue(String field, Class<?> type, @Nullable Object value)
Description copied from interface: `BindingResult`
Record the given value for the specified field.

To be used when a target object cannot be constructed, making the original field values available through `Errors.getFieldValue(java.lang.String)`. In case of a registered error, the rejected value will be exposed for each affected field.

Specified by:
  `recordFieldValue` in interface `BindingResult`
Parameters:
  `field` - the field to record the value for
  `type` - the type of the field
  `value` - the original value

### recordSuppressedField

public void recordSuppressedField(String field)
Description copied from interface: `BindingResult`
Mark the specified disallowed field as suppressed.

The data binder invokes this for each field value that was detected to target a disallowed field.

Specified by:
  `recordSuppressedField` in interface `BindingResult`
See Also:
  - `DataBinder.setAllowedFields(java.lang.String...)`

### getSuppressedFields

public String[] getSuppressedFields()
Description copied from interface: `BindingResult`
Return the list of fields that were suppressed during the bind process.

Can be used to determine whether any field values were targeting disallowed fields.

Specified by:
  `getSuppressedFields` in interface `BindingResult`
See Also:
  - `DataBinder.setAllowedFields(java.lang.String...)`

### getMessage

public String getMessage()
Returns diagnostic information about the errors held in this object.

Overrides:
  `getMessage` in class `Throwable`

### equals

public boolean equals(@Nullable Object other)

Overrides:
  `equals` in class `Object`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`